//+------------------------------------------------------------------+
//|                                                  BumbleBeeFX.mq4 |
//|         Alex Schmidt . Copyright 2014, MetaQuotes Software Corp. |
//|                                           http://bumblebeefx.com |
//+------------------------------------------------------------------+
#property copyright "Alex Schmidt . Copyright 2014, MetaQuotes Software Corp."
#property link      "http://bumblebeefx.com"
#property version   "1.00"
//#import "ipcbus.dll"
//   int CreateBusConnector();
//   void DestroyBusConnector(int a0);
//   bool CreateBus(int a0, string a1);
//   bool OpenBus(int a0, string a1);
//   int CreateConnection(int a0, string a1);
//   bool CloseConnection(int a0);
//   bool Read(int a0, double& a1[], double& a2[]);
//#import
string Gs_76 = "BumbleBeeFX v.1.0";
extern string ___1 = "";
extern double LotSize = 0.1;
extern double OpenPositionDiff = 3.0;
extern double VirtualTakeProfit = 1.0;
extern double VirtualStopLoss = 9.0;
extern int OrderHoldTime = 120;
extern int MaxOrders = 3;
extern int OrdersOpenInterval = 5;
extern bool UseLock = FALSE;
extern bool CloseIfLockFailed = FALSE;
extern bool UseStopOrders = FALSE;
extern int StopOrderHoldTime = 3;
extern string ___2 = "";
extern double StopLoss = 8.0;
extern double TakeProfit = 40.0;
extern int Slippage = 1;
extern int MaxDistance = 6;
extern int MaxAttempts = 3;
extern int Magic1 = 1001;
extern int Magic2 = 1002;
int Gi_196 = 0;
int Gia_200[100][2];
int G_index_204 = 0;
int G_datetime_208 = 0;
double Gd_212 = 0.0;
double Gd_220 = 0.0;
int G_count_228 = 0;
int Gi_unused_232 = 0;
double Gd_236 = 0.0;
double Gd_244 = 0.0;

// james:
bool bDeInit = false;
string sSX = "";
string sSymbol = Symbol();
extern string ___3 = "Misc";
extern bool Reads_Data_From_Common = false;  // Reads data from common files folder.
extern bool Reads_And_Shares_Data = false;

// EA2B2676C28C0DB26D39331A336C6B92
int start() {
   double Lda_0[1];
   double Lda_4[1];
   double ask_8;
   double bid_16;
   double Ld_24;
   while (IsStopped() == FALSE) {
      RefreshRates();
      
      //InitFile();
      LoadFile();
      
      f0_6();
      G_count_228++;
      if (G_count_228 >= 100) {
         f0_13();
         G_count_228 = 0;
      }
      if (Read(Gi_196, Lda_0, Lda_4) && Lda_4[0] > 0.0 && Lda_0[0] > 0.0) {
         if (G_index_204 >= MaxOrders) {
            f0_2(Lda_0[0], Lda_4[0]);
            Gd_236 = Lda_0[0];
            Gd_244 = Lda_4[0];
            continue;
         }
         if (G_index_204 > 0 && TimeCurrent() - G_datetime_208 < OrdersOpenInterval) {
            f0_2(Lda_0[0], Lda_4[0]);
            Gd_236 = Lda_0[0];
            Gd_244 = Lda_4[0];
            continue;
         }
         if (Gd_236 == 0.0 || Gd_244 == 0.0) {
            Gd_236 = Lda_0[0];
            Gd_244 = Lda_4[0];
            continue;
         }
         ask_8 = Ask;
         bid_16 = Bid;
         if (Lda_4[0] > ask_8 && Lda_4[0] - ask_8 >= 5.0 * Gd_212) {
            Print("INFO: LMAX Bid > brokers Ask - BUY (LMAX Bid = ", Lda_4[0], ", brokers Ask = ", ask_8, ", Diff = ", Lda_4[0] - ask_8, ", OpenPositionDiff = ", OpenPositionDiff,
               ")");
         }
         if (bid_16 > Lda_0[0] && bid_16 - Lda_0[0] >= 5.0 * Gd_212) {
            Print("INFO: brokers Bid > LMAX Ask - SELL (LMAX Ask = ", Lda_0[0], ", brokers Bid = ", bid_16, ", Diff = ", bid_16 - Lda_0[0], ", OpenPositionDiff = ", OpenPositionDiff,
               ")");
         }
         if (Lda_4[0] > ask_8 && Lda_4[0] - ask_8 >= OpenPositionDiff && Lda_0[0] > Gd_236 && Lda_4[0] > Gd_244) {
            if (UseStopOrders) {
               Ld_24 = ask_8 + Gd_220 + Gd_212;
               if (Ld_24 < Lda_4[0] - (ask_8 - bid_16) - Gd_212) Gia_200[G_index_204][0] = f0_4(1, f0_12(), Ld_24 - StopLoss - (Ask - Bid), Ld_24 + TakeProfit, Magic1, Ld_24, MaxAttempts, Lda_4[0] - (ask_8 - bid_16) - Gd_212);
            } else Gia_200[G_index_204][0] = f0_3(1, f0_12(), bid_16 - StopLoss, ask_8 + TakeProfit, Magic1, ask_8, MaxAttempts, Lda_4[0] - (ask_8 - bid_16) - Gd_212);
            if (Gia_200[G_index_204][0] > 0 && OrderSelect(Gia_200[G_index_204][0], SELECT_BY_TICKET)) {
               G_datetime_208 = OrderOpenTime();
               f0_0(ask_8, OrderOpenPrice(), 1);
               Print("===> New order BUY opened at ", OrderOpenPrice(), ", broker Ask: ", ask_8, ", LmaxBid: ", Lda_4[0], ", Diff = ", Lda_4[0] - ask_8);
               Gia_200[G_index_204][1] = 0;
               G_index_204++;
               f0_2(Lda_0[0], Lda_4[0]);
               Gd_236 = Lda_0[0];
               Gd_244 = Lda_4[0];
            } else {
            }
         }
         if (bid_16 > Lda_0[0] && bid_16 - Lda_0[0] >= OpenPositionDiff && Lda_0[0] < Gd_236 && Lda_4[0] < Gd_244) {
            if (UseStopOrders) {
               Ld_24 = bid_16 - Gd_220 - Gd_212;
               if (Ld_24 > Lda_0[0] + (ask_8 - bid_16) + Gd_212) Gia_200[G_index_204][0] = f0_4(2, f0_12(), Ld_24 + StopLoss + (Ask - Bid), Ld_24 - TakeProfit, Magic1, Ld_24, MaxAttempts, Lda_0[0] + (ask_8 - bid_16) + Gd_212);
            } else Gia_200[G_index_204][0] = f0_3(2, f0_12(), ask_8 + StopLoss, bid_16 - TakeProfit, Magic1, bid_16, MaxAttempts, Lda_0[0] + (ask_8 - bid_16) + Gd_212);
            if (Gia_200[G_index_204][0] > 0 && OrderSelect(Gia_200[G_index_204][0], SELECT_BY_TICKET)) {
               G_datetime_208 = OrderOpenTime();
               f0_0(bid_16, OrderOpenPrice(), 2);
               Print("===> New order SELL opened at ", OrderOpenPrice(), ", broker Bid: ", bid_16, ", LmaxAsk: ", Lda_0[0], ", Diff = ", bid_16 - Lda_0[0]);
               Gia_200[G_index_204][1] = 0;
               G_index_204++;
               f0_2(Lda_0[0], Lda_4[0]);
               Gd_236 = Lda_0[0];
               Gd_244 = Lda_4[0];
            } else {
            }
         }
         f0_2(Lda_0[0], Lda_4[0]);
         Gd_236 = Lda_0[0];
         Gd_244 = Lda_4[0];
      }
      Sleep(5);
   }
   return (0);
}

// 80B5A943476889553D3B08BB416B52C1
int f0_6() {
   int Li_4;
   int ticket_12;
   int ticket_16;
   int error_20;
   int order_total_8 = OrdersTotal();
   if (order_total_8 == 0 && G_index_204 > 0) {
      f0_11();
      return (0);
   }
   for (int pos_0 = 0; pos_0 < order_total_8; pos_0++) {
      if (OrderSelect(pos_0, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic1 && OrderType() == OP_BUY || OrderType() == OP_SELL) {
         ticket_12 = OrderTicket();
         Li_4 = f0_5(ticket_12);
         if (Li_4 >= 0) {
            if (Gia_200[Li_4][1] > 0 && OrderSelect(Gia_200[Li_4][1], SELECT_BY_TICKET, MODE_TRADES)) {
               if (TimeCurrent() - OrderOpenTime() < OrderHoldTime) continue;
               if (OrderCloseBy(ticket_12, Gia_200[Li_4][1])) {
                  OrderSelect(ticket_12, SELECT_BY_TICKET, MODE_HISTORY);
                  if (OrderType() == OP_BUY) Print("===> BUY Order #", ticket_12, " closed by SELL order #", Gia_200[Li_4][1], ", profit = ", OrderProfit() + OrderCommission());
                  if (OrderType() == OP_SELL) Print("===> SELL Order #", ticket_12, " closed by BUY order #", Gia_200[Li_4][1], ", profit = ", OrderProfit() + OrderCommission());
                  Gia_200[Li_4][0] = 0;
                  Gia_200[Li_4][1] = 0;
                  order_total_8 = OrdersTotal();
                  pos_0 = -1;
               } else {
                  error_20 = GetLastError();
                  Print(" === ERROR: OrderCloseBy(", ticket_12, ", ", Gia_200[Li_4][1], ") failed, ErrorCode = ", error_20, " (", f0_8(error_20), ")");
                  if (error_20 == 3/* INVALID_TRADE_PARAMETERS */) {
                     UseLock = FALSE;
                     Print(" === ERROR: parameter `UseLock` set to `false`!!!   -  !");
                  }
                  Print(" === ERROR: OrderCloseBy(", ticket_12, ", ", Gia_200[Li_4][1], ") failed, ErrorCode = ", error_20, " (", f0_8(error_20), "), both orders removed from DB");
                  Print(" === WARNING: all unknown orders will be closed immediately!");
                  f0_9(ticket_12);
                  f0_9(Gia_200[Li_4][1]);
                  Gia_200[Li_4][0] = 0;
                  Gia_200[Li_4][1] = 0;
                  order_total_8 = OrdersTotal();
                  pos_0 = -1;
               }
            } else {
               if ((!OrderSelect(ticket_12, SELECT_BY_TICKET)) || OrderCloseTime() != 0) Gia_200[Li_4][0] = 0;
               else {
                  if (OrderType() == OP_BUY) {
                     if (!((Bid >= OrderOpenPrice() + VirtualTakeProfit && OrderProfit() + OrderCommission() > 0.0) || OrderOpenPrice() - Bid >= VirtualStopLoss)) continue;
                     if (UseLock) {
                        Gia_200[Li_4][1] = f0_1(ticket_12);
                        if (Gia_200[Li_4][1] <= 0 || (!UseLock)) {
                           if (!(CloseIfLockFailed && f0_9(ticket_12))) continue;
                           Gia_200[Li_4][0] = 0;
                           order_total_8 = OrdersTotal();
                           pos_0 = -1;
                        } else {
                           OrderSelect(Gia_200[Li_4][1], SELECT_BY_TICKET);
                           f0_0(Bid, OrderOpenPrice(), 2);
                           Print("===> Set lock for BUY order #", ticket_12, " by SELL order #", Gia_200[Li_4][1]);
                        }
                     } else {
                        if (!(f0_9(ticket_12))) continue;
                        Gia_200[Li_4][0] = 0;
                        order_total_8 = OrdersTotal();
                        pos_0 = -1;
                     }
                  } else {
                     if (OrderType() != OP_SELL) continue;
                     if (!((Ask <= OrderOpenPrice() - VirtualTakeProfit && OrderProfit() + OrderCommission() > 0.0) || Ask - OrderOpenPrice() >= VirtualStopLoss)) continue;
                     if (UseLock) {
                        Gia_200[Li_4][1] = f0_1(ticket_12);
                        if (Gia_200[Li_4][1] <= 0 || (!UseLock)) {
                           if (!(CloseIfLockFailed && f0_9(ticket_12))) continue;
                           Gia_200[Li_4][0] = 0;
                           order_total_8 = OrdersTotal();
                           pos_0 = -1;
                        } else {
                           OrderSelect(Gia_200[Li_4][1], SELECT_BY_TICKET);
                           f0_0(Ask, OrderOpenPrice(), 2);
                           Print("===> Set lock for SELL order #", ticket_12, " by BUY order #", Gia_200[Li_4][1]);
                        }
                     } else {
                        if (!(f0_9(ticket_12))) continue;
                        Gia_200[Li_4][0] = 0;
                        order_total_8 = OrdersTotal();
                        pos_0 = -1;
                        continue;
                     }
                  }
               }
            }
         }
         if (f0_7(ticket_12) == -1) {
            Print("===> Order #", ticket_12, " added to DB");
            Gia_200[G_index_204][0] = ticket_12;
            Gia_200[G_index_204][1] = 0;
            G_index_204++;
         }
      }
   }
   order_total_8 = OrdersTotal();
   for (pos_0 = 0; pos_0 < order_total_8; pos_0++) {
      if (OrderSelect(pos_0, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic2 && OrderType() == OP_BUY || OrderType() == OP_SELL) {
         ticket_12 = OrderTicket();
         Li_4 = f0_7(ticket_12);
         if (Li_4 == -1) {
            f0_10(ticket_12);
            continue;
         }
         ticket_16 = Gia_200[Li_4][0];
         if (ticket_16 == 0 || (!OrderSelect(ticket_16, SELECT_BY_TICKET)) || OrderCloseTime() != 0) {
            Gia_200[Li_4][0] = 0;
            Gia_200[Li_4][1] = 0;
            f0_10(ticket_12);
         }
      }
   }
   order_total_8 = OrdersTotal();
   for (pos_0 = 0; pos_0 < order_total_8; pos_0++) {
      if (OrderSelect(pos_0, SELECT_BY_POS, MODE_TRADES) && OrderSymbol() == Symbol() && OrderMagicNumber() == Magic1 && OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) {
         if (TimeCurrent() - OrderOpenTime() > StopOrderHoldTime) {
            ticket_12 = OrderTicket();
            switch (OrderType()) {
            case OP_BUYSTOP:
               Print("===> BuyStop order #", ticket_12, " timeout, order will be deleted...");
               break;
            case OP_SELLSTOP:
               Print("===> SellStop order #", ticket_12, " timeout, order will be deleted...");
            }
            if (!OrderDelete(ticket_12)) {
               error_20 = GetLastError();
               Print(" === ERROR: OrderDelete() failed for order #", ticket_12, ", ErrorCode = ", error_20, " (", f0_8(error_20), ")");
            }
         }
      }
   }
   return (1);
}

// 6F7B8024677E7D5805917857C86D9513
int f0_5(int Ai_0) {
   for (int index_4 = 0; index_4 < G_index_204; index_4++)
      if (Gia_200[index_4][0] == Ai_0) return (index_4);
   return (-1);
}

// 985CA256A377F2E6A4181EC68ADB6811
int f0_7(int Ai_0) {
   for (int index_4 = 0; index_4 < G_index_204; index_4++)
      if (Gia_200[index_4][1] == Ai_0) return (index_4);
   return (-1);
}

// C8D4514FE606BCD524BBF616D76CDEBC
void f0_11() {
   for (int index_0 = 0; index_0 < 100; index_0++) {
      Gia_200[index_0][0] = 0;
      Gia_200[index_0][1] = 0;
   }
   G_index_204 = 0;
}

// 1AE99DC0DE8B7C0B6322788DF379294F
int f0_1(int A_ticket_0) {
   double price_4 = 0;
   int ticket_20 = -1;
   int error_24 = 0;
   if ((!OrderSelect(A_ticket_0, SELECT_BY_TICKET)) || OrderCloseTime() != 0) return (-1);
   if (!OrderModify(A_ticket_0, OrderOpenPrice(), 0, 0, 0)) {
      Print(" === ERROR: LockOrder() failed, locked order was unexpectedly closed! exiting...");
      return (-1);
   }
   double order_open_price_12 = OrderOpenPrice();
   switch (OrderType()) {
   case OP_BUY:
      price_4 = Bid;
      ticket_20 = f0_3(2, OrderLots(), 0, 0, Magic2, price_4, MaxAttempts, order_open_price_12 + Gd_212);
      error_24 = GetLastError();
      if (ticket_20 != -1 && OrderSelect(ticket_20, SELECT_BY_TICKET)) f0_0(price_4, OrderOpenPrice(), 2);
      else Print(" === ERROR: LockOrder(): SELL failed, code ", error_24, " (", f0_8(error_24), "), price = ", price_4);
      break;
   case OP_SELL:
      price_4 = Ask;
      ticket_20 = f0_3(1, OrderLots(), 0, 0, Magic2, price_4, MaxAttempts, order_open_price_12 - Gd_212);
      error_24 = GetLastError();
      if (ticket_20 != -1 && OrderSelect(ticket_20, SELECT_BY_TICKET)) f0_0(price_4, OrderOpenPrice(), 1);
      else Print(" === ERROR: LockOrder(): BUY failed, code ", error_24, " (", f0_8(error_24), "), price = ", price_4);
   }
   if (ticket_20 != -1) {
      if (OrderSelect(A_ticket_0, SELECT_BY_TICKET) && OrderCloseTime() != 0) {
         Print(" === ERROR: LockOrder(): locked order was unexpectedly closed! closing lock...");
         f0_10(ticket_20);
         return (-1);
      }
   }
   return (ticket_20);
}

// CA94D06264E6E12ADE176CD9EF33F89E
double f0_12() {
   return (LotSize);
}

// E37F0136AA3FFAF149B351F6A4C948E9
int init() {
   Comment("");
   //Gi_196 = CreateBusConnector();
   //if (Gi_196 == 0) {
   //   Print("Unable to create new BusConnector...");
   //   Alert("Unable to create new BusConnector...");
   //   return (1);
   //}
   //Print("Created new BusConnector (ID: ", Gi_196, ")");
   //if (!CreateBus(Gi_196, Symbol())) {
   //   Print("Unable to create bus (", Symbol(), ")...");
   //   if (!OpenBus(Gi_196, Symbol())) {
   //      Print("Unable to open bus (", Symbol(), ")...");
   //      Alert("Unable to connect to bus (" + Symbol() + ")...");
   //      return (1);
   //   }
   //   Print("Existing IPC bus (", Symbol(), ") opened...");
   //} else Print("IPC bus (", Symbol(), ") created...");
   //int Li_0 = CreateConnection(Gi_196, Gs_76);
   //if (Li_0 == 255) {
   //   Print("Unable to create new connection to bus (" + Symbol() + ")...");
   //   Alert("Unable to create new connection to bus (" + Symbol() + ")...");
   //} else Print("Connection ID: ", Li_0);
   
   
   Gd_220 = MarketInfo(Symbol(), MODE_STOPLEVEL);
   Gd_220 *= Point;
   OpenPositionDiff *= Point;
   VirtualTakeProfit *= Point;
   VirtualStopLoss *= Point;
   StopLoss *= Point;
   TakeProfit *= Point;
   Gd_212 = Point;
   if (Digits == 3 || Digits == 5) {
      OpenPositionDiff = 10.0 * OpenPositionDiff;
      VirtualTakeProfit = 10.0 * VirtualTakeProfit;
      VirtualStopLoss = 10.0 * VirtualStopLoss;
      StopLoss = 10.0 * StopLoss;
      TakeProfit = 10.0 * TakeProfit;
      Slippage = 10 * Slippage;
      Gd_212 = 10.0 * Gd_212;
   }
   if (ObjectFind("bid_lmax") == -1) {
      ObjectCreate("bid_lmax", OBJ_HLINE, 0, TimeCurrent(), Bid);
      ObjectSet("bid_lmax", OBJPROP_COLOR, Yellow);
      ObjectSet("bid_lmax", OBJPROP_STYLE, STYLE_DOT);
   }
   if (ObjectFind("ask_lmax") == -1) {
      ObjectCreate("ask_lmax", OBJ_HLINE, 0, TimeCurrent(), Ask);
      ObjectSet("ask_lmax", OBJPROP_COLOR, Red);
      ObjectSet("ask_lmax", OBJPROP_STYLE, STYLE_DOT);
   }
   if (ObjectFind("bid_label") == -1) ObjectCreate("bid_label", OBJ_TEXT, 0, Time[0], Low[0] - 2.0 * Point);
   if (ObjectFind("ask_label") == -1) ObjectCreate("ask_label", OBJ_TEXT, 0, Time[0], High[0] + 2.0 * Point);
   ObjectSetText("ask_label", "0", 10, "Tahoma", Lime);
   ObjectSetText("bid_label", "0", 10, "Tahoma", Lime);
   return (0);
}

// 52D46093050F38C27267BCE42543EF60
int deinit() {
   //CloseConnection(Gi_196);
   //DestroyBusConnector(Gi_196);
   Comment("");
   ObjectDelete("bid_lmax");
   ObjectDelete("ask_lmax");
   ObjectDelete("bid_label");
   ObjectDelete("ask_label");
   if (ObjectFind("INFO_BACKGROUND") >= 0) ObjectDelete("INFO_BACKGROUND");
   if (ObjectFind("INFO_BACKGROUND2") >= 0) ObjectDelete("INFO_BACKGROUND2");
   if (ObjectFind("INFO_LABEL_TEXT") >= 0) ObjectDelete("INFO_LABEL_TEXT");
   if (ObjectFind("INFO_LABEL_TEXT2") >= 0) ObjectDelete("INFO_LABEL_TEXT2");
   return (0);
}

// 2FB579C4EDC682321971F9046141A6CD
void f0_2(double Ad_0, double Ad_8) {
   ObjectMove("ask_lmax", 0, TimeCurrent(), Ad_0);
   ObjectMove("bid_lmax", 0, TimeCurrent(), Ad_8);
   if (Ad_8 > Bid) ObjectSetText("bid_label", DoubleToStr((Ad_8 - Bid) / Point, 0), 10, "Tahoma", Red);
   else ObjectSetText("bid_label", DoubleToStr((Bid - Ad_8) / Point, 0), 10, "Tahoma", Lime);
   ObjectMove("bid_label", 0, Time[0], Low[0] - 0.8 * Gd_212);
   if (Ask > Ad_0) ObjectSetText("ask_label", DoubleToStr((Ask - Ad_0) / Point, 0), 10, "Tahoma", Red);
   else ObjectSetText("ask_label", DoubleToStr((Ad_0 - Ask) / Point, 0), 10, "Tahoma", Lime);
   if (High[0] > Ask) {
      ObjectMove("ask_label", 0, Time[0], High[0] + 1.6 * Gd_212);
      return;
   }
   ObjectMove("ask_label", 0, Time[0], Ask + Gd_212);
}

// 3979B36778CB41DC3EF6DCDC816A5E75
int f0_3(int Ai_0, double A_lots_4, double A_price_12, double A_price_20, int A_magic_28, double A_price_32 = 0.0, int Ai_40 = 1, double Ad_44 = 0.0) {
   int error_60;
   double price_72;
   double price_80;
   int ticket_56 = -1;
   double price_64 = 0;
   if (!IsConnected()) {
      Print(" === ERROR: OpenNewOrder() -> !IsConnected()");
      return (-1);
   }
   for (int count_52 = 0; IsTradeContextBusy() && count_52 < Ai_40; count_52++) Sleep(50);
   if (IsTradeContextBusy()) {
      error_60 = GetLastError();
      Print(" === ERROR: OpenNewOrder() -> trade context busy", error_60, " (", f0_8(error_60), ")");
      return (-1);
   }
   price_64 = A_price_32;
   for (count_52 = 0; ticket_56 < 0 && count_52 < Ai_40; count_52++) {
      switch (Ai_0) {
      case 1:
         if (count_52 == 0) {
            Print(" === OpenNewOrder(): New BUY order parameters: price = ", A_price_32, ", Magic = ", A_magic_28, ", SL = ", A_price_12, ", TP = ", A_price_20);
            ticket_56 = OrderSend(Symbol(), OP_BUY, A_lots_4, NormalizeDouble(A_price_32, Digits), Slippage, A_price_12, A_price_20, 0, A_magic_28, 0, Blue);
            if (ticket_56 <= 0) break;
            Print(" === OpenNewOrder(): New BUY order #", ticket_56, " opened at ", OrderOpenPrice(), ", Requested price = ", A_price_32, ", MaxPrice = ", Ad_44, ", Magic = ",
               OrderMagicNumber(), ", SL = ", A_price_12, ", TP = ", A_price_20);
         } else {
            price_64 = MarketInfo(Symbol(), MODE_ASK);
            if (Ad_44 > 0.0 && price_64 > Ad_44) {
               Print(" === ERROR: OpenNewOrder() BUY -> the price has gone too far (MaxPrice = ", Ad_44, ", Ask = ", price_64, ")");
               return (-1);
            }
            price_72 = A_price_12 + price_64 - A_price_32;
            price_80 = A_price_20 + price_64 - A_price_32;
            if (A_price_12 <= 0.0) price_72 = 0;
            if (A_price_20 <= 0.0) price_80 = 0;
            Print(" === OpenNewOrder(): New BUY order parameters: price = ", price_64, ", Magic = ", A_magic_28, ", SL = ", price_72, ", TP = ", price_80);
            ticket_56 = OrderSend(Symbol(), OP_BUY, A_lots_4, NormalizeDouble(price_64, Digits), Slippage, price_72, price_80, 0, A_magic_28, 0, Blue);
            if (ticket_56 <= 0) break;
            Print(" === OpenNewOrder(): New BUY order #", ticket_56, " opened at ", OrderOpenPrice(), ", Requested price = ", A_price_32, ", MaxPrice = ", Ad_44, ", Magic = ",
               OrderMagicNumber(), ", SL = ", price_72, ", TP = ", price_80);
         }
         break;
      case 2:
         if (count_52 == 0) {
            Print(" === OpenNewOrder(): New SELL order parameters: price = ", A_price_32, ", Magic = ", A_magic_28, ", SL = ", A_price_12, ", TP = ", A_price_20);
            ticket_56 = OrderSend(Symbol(), OP_SELL, A_lots_4, NormalizeDouble(A_price_32, Digits), Slippage, A_price_12, A_price_20, 0, A_magic_28, 0, Red);
            if (ticket_56 <= 0) break;
            Print(" === OpenNewOrder(): New SELL order #", ticket_56, " opened at ", OrderOpenPrice(), ", Requested price = ", A_price_32, ", MaxPrice = ", Ad_44, ", Magic = ",
               OrderMagicNumber(), ", SL = ", A_price_12, ", TP = ", A_price_20);
         } else {
            price_64 = MarketInfo(Symbol(), MODE_BID);
            if (Ad_44 > 0.0 && Ad_44 > price_64) {
               Print(" === ERROR: OpenNewOrder() SELL -> the price has gone too far (MaxPrice = ", Ad_44, ", Bid = ", price_64, ")");
               return (-1);
            }
            price_72 = A_price_12 + price_64 - A_price_32;
            price_80 = A_price_20 + price_64 - A_price_32;
            if (A_price_12 <= 0.0) price_72 = 0;
            if (A_price_20 <= 0.0) price_80 = 0;
            Print(" === OpenNewOrder(): New SELL order parameters: price = ", price_64, ", Magic = ", A_magic_28, ", SL = ", price_72, ", TP = ", price_80);
            ticket_56 = OrderSend(Symbol(), OP_SELL, A_lots_4, NormalizeDouble(price_64, Digits), Slippage, price_72, price_80, 0, A_magic_28, 0, Red);
            if (ticket_56 <= 0) break;
            Print(" === OpenNewOrder(): New SELL order #", ticket_56, " opened at ", OrderOpenPrice(), ", Requested price = ", A_price_32, ", MaxPrice = ", Ad_44, ", Magic = ",
               OrderMagicNumber(), ", SL = ", price_72, ", TP = ", price_80);
         }
      }
      if (ticket_56 < 0) {
         error_60 = GetLastError();
         Print(" === ERROR: OpenNewOrder() -> OderSend() error, code ", error_60, " (", f0_8(error_60), "), price = ", price_64, ", total attempts to open order: ", count_52 +
            1);
         if (error_60 == 149/* TRADE_HEDGE_PROHIBITED */) {
            UseLock = FALSE;
            Print(" === ERROR: OpenNewOrder() -> OderSend() error, code 149 (ERR_TRADE_HEDGE_PROHIBITED), exiting");
            return (-1);
         }
         if (error_60 == 1/* NO_RESULT */ || error_60 == 6/* NO_CONNECTION */ || error_60 == 128/* TRADE_TIMEOUT */) {
            if (error_60 == 1/* NO_RESULT */) Print(" === ERROR: OpenNewOrder() -> OderSend() error, code 1 (ERR_NO_RESULT), exiting...");
            if (error_60 == 6/* NO_CONNECTION */) Print(" === ERROR: OpenNewOrder() -> OderSend() error, code 6 (ERR_NO_CONNECTION), exiting...");
            if (error_60 == 128/* TRADE_TIMEOUT */) Print(" === ERROR: OpenNewOrder() -> OderSend() error, code 128 (ERR_TRADE_TIMEOUT), exiting...");
            Sleep(300);
            return (-1);
         }
      }
      if (ticket_56 < 0 && count_52 < Ai_40 - 1) Sleep(50);
   }
   return (ticket_56);
}

// 46309EF3CA20B47597B419BEC1EC1A55
int f0_4(int Ai_0, double A_lots_4, double Ad_12, double Ad_20, int A_magic_28, double Ad_32 = 0.0, int Ai_40 = 1, double Ad_44 = 0.0) {
   int error_60;
   double Ld_72;
   double Ld_80;
   int ticket_56 = -1;
   double Ld_64 = 0;
   if (!IsConnected()) {
      Print(" === ERROR: OpenNewStopOrder() -> !IsConnected()");
      return (-1);
   }
   for (int count_52 = 0; IsTradeContextBusy() && count_52 < Ai_40; count_52++) Sleep(50);
   if (IsTradeContextBusy()) {
      error_60 = GetLastError();
      Print(" === ERROR: OpenNewStopOrder() -> trade context busy", error_60, " (", f0_8(error_60), ")");
      return (-1);
   }
   Ld_64 = Ad_32;
   for (count_52 = 0; ticket_56 < 0 && count_52 < Ai_40; count_52++) {
      switch (Ai_0) {
      case 1:
         if (count_52 == 0) {
            ticket_56 = OrderSend(Symbol(), OP_BUYSTOP, A_lots_4, NormalizeDouble(Ad_32, Digits), Slippage, NormalizeDouble(Ad_12, Digits), NormalizeDouble(Ad_20, Digits), 0,
               A_magic_28, 0, Blue);
            Print(" === OpenNewStopOrder(): New BUYSTOP order parameters: price = ", Ad_32, ", Magic = ", A_magic_28, ", SL = ", Ad_12, ", TP = ", Ad_20, ", Ask = ", Ask, ", Bid = ",
               Bid);
            if (ticket_56 <= 0) break;
            Print(" === OpenNewStopOrder(): New BUYSTOP order #", ticket_56, " set at ", OrderOpenPrice(), ", Requested price = ", Ad_32, ", MaxPrice = ", Ad_44, ", Magic = ",
               OrderMagicNumber(), ", SL = ", Ad_12, ", TP = ", Ad_20);
         } else {
            Ld_64 = MarketInfo(Symbol(), MODE_ASK) + Gd_220 + Gd_212;
            if (Ad_44 > 0.0 && Ld_64 > Ad_44) {
               Print(" === ERROR: OpenNewStopOrder() BUYSTOP -> the price has gone too far (MaxPrice = ", Ad_44, ", Price = ", Ld_64, ")");
               return (-1);
            }
            Ld_72 = Ad_12 + Ld_64 - Ad_32;
            Ld_80 = Ad_20 + Ld_64 - Ad_32;
            if (Ad_12 <= 0.0) Ld_72 = 0;
            if (Ad_20 <= 0.0) Ld_80 = 0;
            ticket_56 = OrderSend(Symbol(), OP_BUYSTOP, A_lots_4, NormalizeDouble(Ld_64, Digits), Slippage, NormalizeDouble(Ld_72, Digits), NormalizeDouble(Ld_80, Digits), 0,
               A_magic_28, 0, Blue);
            Print(" === OpenNewStopOrder(): New BUYSTOP order parameters: price = ", Ld_64, ", Magic = ", A_magic_28, ", SL = ", Ld_72, ", TP = ", Ld_80, ", Ask = ", Ask, ", Bid = ",
               Bid);
            if (ticket_56 <= 0) break;
            Print(" === OpenNewStopOrder(): New BUYSTOP order #", ticket_56, " set at ", OrderOpenPrice(), ", Requested price = ", Ad_32, ", MaxPrice = ", Ad_44, ", Magic = ",
               OrderMagicNumber(), ", SL = ", Ld_72, ", TP = ", Ld_80);
         }
         break;
      case 2:
         if (count_52 == 0) {
            ticket_56 = OrderSend(Symbol(), OP_SELLSTOP, A_lots_4, NormalizeDouble(Ad_32, Digits), Slippage, NormalizeDouble(Ad_12, Digits), NormalizeDouble(Ad_20, Digits), 0,
               A_magic_28, 0, Red);
            Print(" === OpenNewStopOrder(): New SELLSTOP order parameters: price = ", Ad_32, ", Magic = ", A_magic_28, ", SL = ", Ad_12, ", TP = ", Ad_20, ", Ask = ", Ask, ", Bid = ",
               Bid);
            if (ticket_56 <= 0) break;
            Print(" === OpenNewStopOrder(): New SELLSTOP order #", ticket_56, " set at ", OrderOpenPrice(), ", Requested price = ", Ad_32, ", MaxPrice = ", Ad_44, ", Magic = ",
               OrderMagicNumber(), ", SL = ", Ad_12, ", TP = ", Ad_20);
         } else {
            Ld_64 = MarketInfo(Symbol(), MODE_BID) - Gd_220 - Gd_212;
            if (Ad_44 > 0.0 && Ad_44 > Ld_64) {
               Print(" === ERROR: OpenNewStopOrder() SellStop -> the price has gone too far (MaxPrice = ", Ad_44, ", Price = ", Ld_64, ")");
               return (-1);
            }
            Ld_72 = Ad_12 + Ld_64 - Ad_32;
            Ld_80 = Ad_20 + Ld_64 - Ad_32;
            if (Ad_12 <= 0.0) Ld_72 = 0;
            if (Ad_20 <= 0.0) Ld_80 = 0;
            ticket_56 = OrderSend(Symbol(), OP_SELLSTOP, A_lots_4, NormalizeDouble(Ld_64, Digits), Slippage, NormalizeDouble(Ld_72, Digits), NormalizeDouble(Ld_80, Digits), 0,
               A_magic_28, 0, Red);
            Print(" === OpenNewStopOrder(): New SELLSTOP order parameters: price = ", Ld_64, ", Magic = ", A_magic_28, ", SL = ", Ld_72, ", TP = ", Ld_80, ", Ask = ", Ask, ", Bid = ",
               Bid);
            if (ticket_56 <= 0) break;
            Print(" === OpenNewStopOrder(): New SELLSTOP order #", ticket_56, " set at ", OrderOpenPrice(), ", Requested price = ", Ad_32, ", MaxPrice = ", Ad_44, ", Magic = ",
               OrderMagicNumber(), ", SL = ", Ld_72, ", TP = ", Ld_80);
         }
      }
      if (ticket_56 < 0) {
         error_60 = GetLastError();
         Print(" === ERROR: OpenNewStopOrder() -> OderSend() error, code ", error_60, " (", f0_8(error_60), "), price = ", Ld_64, ", total attempts to open order: ", count_52 +
            1);
         if (error_60 == 149/* TRADE_HEDGE_PROHIBITED */) {
            UseLock = FALSE;
            Print(" === ERROR: OpenNewStopOrder() -> OderSend() error, code 149 (ERR_TRADE_HEDGE_PROHIBITED), exiting");
            return (-1);
         }
         if (error_60 == 1/* NO_RESULT */ || error_60 == 6/* NO_CONNECTION */ || error_60 == 128/* TRADE_TIMEOUT */) {
            if (error_60 == 1/* NO_RESULT */) Print(" === ERROR: OpenNewStopOrder() -> OderSend() error, code 1 (ERR_NO_RESULT), exiting...");
            if (error_60 == 6/* NO_CONNECTION */) Print(" === ERROR: OpenNewStopOrder() -> OderSend() error, code 6 (ERR_NO_CONNECTION), exiting...");
            if (error_60 == 128/* TRADE_TIMEOUT */) Print(" === ERROR: OpenNewStopOrder() -> OderSend() error, code 128 (ERR_TRADE_TIMEOUT), exiting...");
            Sleep(300);
            return (-1);
         }
      }
      if (ticket_56 < 0 && count_52 < Ai_40 - 1) Sleep(50);
   }
   return (ticket_56);
}

// B26D127601F0E8CF3AC131D700FA0518
int f0_9(int A_ticket_0) {
   if (f0_10(A_ticket_0) && OrderSelect(A_ticket_0, SELECT_BY_TICKET, MODE_HISTORY)) {
      if (OrderProfit() + OrderCommission() > 0.0) {
         if (OrderType() == OP_BUY) Print("===> BUY Order #", A_ticket_0, " was closed by virtual TakeProfit, profit = ", OrderProfit() + OrderCommission());
         if (OrderType() == OP_SELL) Print("===> SELL Order #", A_ticket_0, " was closed by virtual TakeProfit, profit = ", OrderProfit() + OrderCommission());
      } else {
         if (OrderType() == OP_BUY) Print("===> BUY Order #", A_ticket_0, " was closed by virtual StopLoss, profit = ", OrderProfit() + OrderCommission());
         if (OrderType() == OP_SELL) Print("===> SELL Order #", A_ticket_0, " was closed by virtual StopLoss, profit = ", OrderProfit() + OrderCommission());
      }
      return (1);
   }
   return (0);
}

// C0C3DCFC5C04BE582D6425F14976481B
int f0_10(int A_ticket_0, double Ad_4 = 0.0, int A_slippage_12 = 0, color A_color_16 = -1) {
   int error_28;
   double order_lots_32;
   int count_20 = 0;
   int Li_unused_24 = 0;
   if (!OrderSelect(A_ticket_0, SELECT_BY_TICKET) && OrderCloseTime() == 0) return (0);
   if (Ad_4 == 0.0) order_lots_32 = OrderLots();
   else order_lots_32 = Ad_4;
   while (IsTradeContextBusy() && count_20 < 10) {
      Sleep(30);
      count_20++;
   }
   count_20 = 0;
   if ((!IsTradeContextBusy()) && IsTradeAllowed()) {
      while (count_20 < 5) {
         RefreshRates();
         switch (OrderType()) {
         case OP_BUY:
            if (A_color_16 == CLR_NONE) A_color_16 = Blue;
            if (OrderClose(A_ticket_0, order_lots_32, NormalizeDouble(Bid, Digits), A_slippage_12, A_color_16)) return (1);
            error_28 = GetLastError();
            Print(" === ERROR:   ,  ", error_28, " (", f0_8(error_28), ")");
            count_20++;
            Sleep(50);
            break;
         case OP_SELL:
            if (A_color_16 == CLR_NONE) A_color_16 = Red;
            if (OrderClose(A_ticket_0, order_lots_32, NormalizeDouble(Ask, Digits), A_slippage_12, A_color_16)) return (1);
            error_28 = GetLastError();
            Print(" === ERROR:   ,  ", error_28, " (", f0_8(error_28), ")");
            count_20++;
            Sleep(50);
         }
      }
   }
   return (0);
}

// 09B0E2890B2B5499C4B3FBA9B4F736CC
void f0_0(double Ad_0, double Ad_8, int Ai_16) {
   double Ld_20 = MathAbs(Ad_0 - Ad_8) / Point;
   if (Digits == 3 || Digits == 5) Ld_20 /= 10.0;
   if (Ai_16 == 1) {
      if (Ad_8 > Ad_0) Print("---- (!!!) Negative slippage: ", Ld_20, " points");
      if (Ad_8 < Ad_0) Print("---- (+++) Positive slippage: ", Ld_20, " points");
   }
   if (Ai_16 == 2) {
      if (Ad_8 < Ad_0) Print("---- (!!!) Negative slippage: ", Ld_20, " points");
      if (Ad_8 > Ad_0) Print("---- (+++) Positive slippage: ", Ld_20, " points");
   }
}

// A662713EF5F78DC78D01E7976C730A5B
string f0_8(int Ai_0) {
   string Ls_ret_4 = "";
   switch (Ai_0) {
   case 0:
      Ls_ret_4 = " ";
      break;
   case 1:
      Ls_ret_4 = " ,   ";
      break;
   case 2:
      Ls_ret_4 = " ";
      break;
   case 3:
      Ls_ret_4 = " ";
      break;
   case 4:
      Ls_ret_4 = "  ";
      break;
   case 5:
      Ls_ret_4 = "   ";
      break;
   case 6:
      Ls_ret_4 = "    ";
      break;
   case 7:
      Ls_ret_4 = " ";
      break;
   case 8:
      Ls_ret_4 = "  ";
      break;
   case 9:
      Ls_ret_4 = "   ";
      break;
   case 64:
      Ls_ret_4 = " ";
      break;
   case 65:
      Ls_ret_4 = "  ";
      break;
   case 128:
      Ls_ret_4 = "    ";
      break;
   case 129:
      Ls_ret_4 = " ";
      break;
   case 130:
      Ls_ret_4 = " ";
      break;
   case 131:
      Ls_ret_4 = " ";
      break;
   case 132:
      Ls_ret_4 = " ";
      break;
   case 133:
      Ls_ret_4 = " ";
      break;
   case 134:
      Ls_ret_4 = "    ";
      break;
   case 135:
      Ls_ret_4 = " ";
      break;
   case 136:
      Ls_ret_4 = " ";
      break;
   case 137:
      Ls_ret_4 = " ";
      break;
   case 138:
      Ls_ret_4 = " ";
      break;
   case 139:
      Ls_ret_4 = "    ";
      break;
   case 140:
      Ls_ret_4 = "  ";
      break;
   case 141:
      Ls_ret_4 = "  ";
      break;
   case 145:
      Ls_ret_4 = " ,     ";
      break;
   case 146:
      Ls_ret_4 = "  ";
      break;
   case 147:
      Ls_ret_4 = "     ";
      break;
   case 148:
      Ls_ret_4 = "   .";
      break;
   case 4000:
      Ls_ret_4 = " ";
      break;
   case 4001:
      Ls_ret_4 = "  ";
      break;
   case 4002:
      Ls_ret_4 = "  -  ";
      break;
   case 4003:
      Ls_ret_4 = "    ";
      break;
   case 4004:
      Ls_ret_4 = "    ";
      break;
   case 4005:
      Ls_ret_4 = "      ";
      break;
   case 4006:
      Ls_ret_4 = "    ";
      break;
   case 4007:
      Ls_ret_4 = "    ";
      break;
   case 4008:
      Ls_ret_4 = " ";
      break;
   case 4009:
      Ls_ret_4 = "   ";
      break;
   case 4010:
      Ls_ret_4 = "    ";
      break;
   case 4011:
      Ls_ret_4 = "  ";
      break;
   case 4012:
      Ls_ret_4 = "    ";
      break;
   case 4013:
      Ls_ret_4 = "  ";
      break;
   case 4014:
      Ls_ret_4 = " ";
      break;
   case 4015:
      Ls_ret_4 = " ";
      break;
   case 4016:
      Ls_ret_4 = " ";
      break;
   case 4017:
      Ls_ret_4 = " DLL  ";
      break;
   case 4018:
      Ls_ret_4 = "  ";
      break;
   case 4019:
      Ls_ret_4 = "  ";
      break;
   case 4020:
      Ls_ret_4 = "     ";
      break;
   case 4021:
      Ls_ret_4 = "   ,   ";
      break;
   case 4022:
      Ls_ret_4 = " ";
      break;
   case 4050:
      Ls_ret_4 = "   ";
      break;
   case 4051:
      Ls_ret_4 = "   ";
      break;
   case 4052:
      Ls_ret_4 = "   ";
      break;
   case 4053:
      Ls_ret_4 = " ";
      break;
   case 4054:
      Ls_ret_4 = "  -";
      break;
   case 4055:
      Ls_ret_4 = "  ";
      break;
   case 4056:
      Ls_ret_4 = " ";
      break;
   case 4057:
      Ls_ret_4 = "   ";
      break;
   case 4058:
      Ls_ret_4 = "   ";
      break;
   case 4059:
      Ls_ret_4 = "     ";
      break;
   case 4060:
      Ls_ret_4 = "  ";
      break;
   case 4061:
      Ls_ret_4 = "  ";
      break;
   case 4062:
      Ls_ret_4 = "   string";
      break;
   case 4063:
      Ls_ret_4 = "   integer";
      break;
   case 4064:
      Ls_ret_4 = "   double";
      break;
   case 4065:
      Ls_ret_4 = "    ";
      break;
   case 4066:
      Ls_ret_4 = "     ";
      break;
   case 4067:
      Ls_ret_4 = "    ";
      break;
   case 4099:
      Ls_ret_4 = " ";
      break;
   case 4100:
      Ls_ret_4 = "    ";
      break;
   case 4101:
      Ls_ret_4 = "  ";
      break;
   case 4102:
      Ls_ret_4 = "   ";
      break;
   case 4103:
      Ls_ret_4 = "  ";
      break;
   case 4104:
      Ls_ret_4 = "    ";
      break;
   case 4105:
      Ls_ret_4 = "    ";
      break;
   case 4106:
      Ls_ret_4 = " ";
      break;
   case 4107:
      Ls_ret_4 = "     ";
      break;
   case 4108:
      Ls_ret_4 = "  ";
      break;
   case 4109:
      Ls_ret_4 = "  .   .";
      break;
   case 4110:
      Ls_ret_4 = "   .    .";
      break;
   case 4111:
      Ls_ret_4 = "   .    .";
      break;
   case 4200:
      Ls_ret_4 = "  ";
      break;
   case 4201:
      Ls_ret_4 = "   ";
      break;
   case 4202:
      Ls_ret_4 = "  ";
      break;
   case 4203:
      Ls_ret_4 = "  ";
      break;
   case 4204:
      Ls_ret_4 = "  ";
      break;
   case 4205:
      Ls_ret_4 = "  ";
      break;
   case 4206:
      Ls_ret_4 = "   ";
      break;
   case 4207:
      Ls_ret_4 = "    ";
      break;
   default:
      Ls_ret_4 = " ";
   }
   return (Ls_ret_4);
}

// E43857C44F7A3268C1A71DF7A2150CCA
void f0_13() {
   string Ls_0 = "";
   Ls_0 = " \n " 
      + "\n----------------------------------------------------------" 
      + "\n  Copyright  shadowsmaster" 
      + "\n ---------------------------------------------------------" 
      + "\n  " + AccountCompany() 
      + "\n  Server Time: " + TimeToStr(TimeCurrent(), TIME_SECONDS) 
   + "\n ---------------------------------------------------------";
   Ls_0 = Ls_0 
      + "\n" 
   + "\n  Balance: " + DoubleToStr(AccountBalance(), 1);
   if (AccountBalance() > 0.0) {
      Ls_0 = Ls_0 
      + "\n  Current profit: " + DoubleToStr(AccountProfit(), 1) + " (" + DoubleToStr(AccountProfit() / (AccountBalance() / 100.0), 1) + "%)";
   } else {
      Ls_0 = Ls_0 
      + "\n";
   }
   Ls_0 = Ls_0 
      + "\n  OrdersDB positions: " + G_index_204 
      + "\n" 
      + "\n ---------------------------------------------------------" + " \n " + " \n " 
   + "\n ---------------------------------------------------------";
   Comment(Ls_0);
   if (ObjectFind("INFO_BACKGROUND") < 0) {
      ObjectCreate("INFO_BACKGROUND", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("INFO_BACKGROUND", "g", 130, "Webdings", LightSlateGray);
      ObjectSet("INFO_BACKGROUND", OBJPROP_CORNER, 0);
      ObjectSet("INFO_BACKGROUND", OBJPROP_BACK, TRUE);
      ObjectSet("INFO_BACKGROUND", OBJPROP_XDISTANCE, 5);
      ObjectSet("INFO_BACKGROUND", OBJPROP_YDISTANCE, 15);
   }
   if (ObjectFind("INFO_BACKGROUND2") < 0) {
      ObjectCreate("INFO_BACKGROUND2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("INFO_BACKGROUND2", "g", 130, "Webdings", DarkGray);
      ObjectSet("INFO_BACKGROUND2", OBJPROP_CORNER, 0);
      ObjectSet("INFO_BACKGROUND2", OBJPROP_BACK, TRUE);
      ObjectSet("INFO_BACKGROUND2", OBJPROP_XDISTANCE, 5);
      ObjectSet("INFO_BACKGROUND2", OBJPROP_YDISTANCE, 42);
   }
   if (ObjectFind("INFO_LABEL_TEXT") < 0) {
      ObjectCreate("INFO_LABEL_TEXT", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("INFO_LABEL_TEXT", " " + Gs_76, 10, "Verdana", White);
      ObjectSet("INFO_LABEL_TEXT", OBJPROP_CORNER, 0);
      ObjectSet("INFO_LABEL_TEXT", OBJPROP_BACK, FALSE);
      ObjectSet("INFO_LABEL_TEXT", OBJPROP_XDISTANCE, 13);
      ObjectSet("INFO_LABEL_TEXT", OBJPROP_YDISTANCE, 21);
   }
   if (ObjectFind("INFO_LABEL_TEXT2") < 0) {
      ObjectCreate("INFO_LABEL_TEXT2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("INFO_LABEL_TEXT2", "~", 11, "Webdings", Yellow);
      ObjectSet("INFO_LABEL_TEXT2", OBJPROP_CORNER, 0);
      ObjectSet("INFO_LABEL_TEXT2", OBJPROP_BACK, FALSE);
      ObjectSet("INFO_LABEL_TEXT2", OBJPROP_XDISTANCE, 157);
      ObjectSet("INFO_LABEL_TEXT2", OBJPROP_YDISTANCE, 19);
   }
   ObjectSet("INFO_LABEL_TEXT2", OBJPROP_COLOR, Yellow);
}


bool LoadFile()
{
   string header = "", line = "", lineTmp = "";
   string lines[];
   
   // loads the file (if sharing):
   while(Reads_And_Shares_Data)
   {
      int file_handle = INVALID_HANDLE;//FileOpen("sx.ini", FILE_READ|FILE_TXT);
      if (Reads_Data_From_Common){
         file_handle = FileOpen("sx.ini", FILE_SHARE_READ|FILE_TXT|FILE_COMMON);
      }
      else{
         file_handle = FileOpen("sx.ini", FILE_SHARE_READ|FILE_TXT);
      }
      if(file_handle == INVALID_HANDLE)
      {
         Sleep(2);
         continue;
      }
      
      while(!FileIsEnding(file_handle))
      {
         line = FileReadString(file_handle);
         sSX += line + "~";
         
         //if (StringFind(line, "kol=") != -1)
         //{
         //   lineTmp = StringSubstr(line, 4);
         //   header = lineTmp + (StringLen(lineTmp) == 2 ? " " : "");
         //}
         //if (StringFind(line, "kols=") != -1)
         //{
         //   lineTmp = StringSubstr(line, 5);
         //   header += lineTmp;
         //}
      }
      FileClose(file_handle);
      
      // work with file data:
      int count = StringSplit(sSX, StringGetCharacter("~", 0), lines);
      for(int idx=0; idx<count; idx++)
      {
         //Print(StringFind(lines[idx], "kol="));
         if (StringSubstr(lines[idx], 0, 1) == "[" && StringFind(lines[idx], "kol=") == -1)
         {
            // get symbol:
            string sym = lines[idx];
            StringReplace(sym, "[", "");
            StringReplace(sym, "]", "");
            //Print("Symbol=", sym);
            
            // get data:
            GlobalVariableSet("NHv2_bid_" + sym, StringToDouble(StringSubstr(lines[++idx],4)));
            GlobalVariableSet("NHv2_ask_" + sym, StringToDouble(StringSubstr(lines[++idx],4)));
         }
      }
      //Print("Global Updated");
      return;
   }
}

bool Read(int ID, double& ask[], double& bid[])
{
   int idx;
   
   // Read from global:
   bid[0] = GlobalVariableGet("NHv2_bid_" + Symbol());
   ask[0] = GlobalVariableGet("NHv2_ask_" + Symbol());
   
   // show GV values:
   //string cmnt = "";
   //for(idx=0; idx<GlobalVariablesTotal(); idx++)
   //{
   //   string sGVName = GlobalVariableName(idx);
   //   cmnt += StringConcatenate("\n", sGVName, " = ", GlobalVariableGet(sGVName));
   //}
   //Comment(cmnt);
   return true;
   
   
   //double bid, ask;
   
   // returns the latest price
   string lines[];
   
   // split:
   int count = StringSplit(sSX, StringGetCharacter("~", 0), lines);
   for(idx=0; idx<count; idx++)
   {
   
      if (lines[idx] == StringConcatenate("[", sSymbol, "]"))
      {
         //Print(lines[idx+1]);
         bid[0] = StringToDouble(StringSubstr(lines[idx+1],4));
         ask[0] = StringToDouble(StringSubstr(lines[idx+2],4));
         return true;
      }
   }
   
   return false;
}

string InitFile()
{
   // C:\Users\James\AppData\Roaming\MetaQuotes\Terminal\30D279B64B1858168C932D8264853F2B\MQL4\Files\sx.ini
   string header = "", line = "", lineTmp = "";
   sSX = "";
   
   // load file:
   while(Reads_And_Shares_Data)
   {
      int file_handle = INVALID_HANDLE;//FileOpen("sx.ini", FILE_READ|FILE_TXT);
      if (Reads_Data_From_Common){
         file_handle = FileOpen("sx.ini", FILE_SHARE_READ|FILE_TXT|FILE_COMMON);
      }
      else{
         file_handle = FileOpen("sx.ini", FILE_SHARE_READ|FILE_TXT);
      }
      if(file_handle == INVALID_HANDLE)
      {
         Sleep(4);
         continue;
      }
   
      while(!FileIsEnding(file_handle))
      {
         line = FileReadString(file_handle);
         sSX += line + "~";
         
         if (StringFind(line, "kol=") != -1)
         {
            lineTmp = StringSubstr(line, 4);
            header = lineTmp + (StringLen(lineTmp) == 2 ? " " : "");
         }
         if (StringFind(line, "kols=") != -1)
         {
            lineTmp = StringSubstr(line, 5);
            header += lineTmp;
         }
      }
      FileClose(file_handle);
      return header;
   }
}
//string GetBidAsk(string symbol)
//{
//   string lines[];
//   
//   // split:
//   int count = StringSplit(sSX, StringGetCharacter("~", 0), lines);
//   for(int idx=0; idx<count; idx++)
//   {
//      if (lines[idx] == StringConcatenate("[", symbol, "]"))
//      {
//         return StringConcatenate(
//            StringSubstr(lines[idx+1], 4)
//            , "!"
//            , StringSubstr(lines[idx+2], 4)
//         );
//      }
//   }
//}